Sketcher SketchObject

From FreeCAD Documentation
Revision as of 23:32, 17 January 2020 by Maker (talk | contribs) (Created page with "Skizzierer SkizzeObjekt")
(diff) ← Older revision | Latest revision (diff) | Newer revision → (diff)

Introduction

A Sketcher SketchObject, or formally a Sketcher::SketchObject, is the base element to create 2D objects with the Sketcher Workbench.

The Sketcher::SketchObject is derived from Part Part2DObject, which means it is a Part Feature object specialized for 2D geometry. Like Part2DObject, the SketchObject can be attached to planes and faces. In addition, the SketchObject can handle geometrical constraints of the lines and curves that are drawn within it.

Simplified diagram of the relationships between the core objects in FreeCAD. The Sketcher::SketchObject class is specialized for 2D shapes, and additionally it can handle geometrical constraints of its elements.

How to use

  1. Switch to the Sketcher Workbench.
  2. Press Sketcher NewSketch.
  3. Select a Sketch orientation: XY-plane, XZ-plane, or YZ-plane. Optionally also choose Reverse direction, and give an Offset value.
  4. Press OK.

Although the SketchObject can be used by itself to draw on a plane, it is most commonly used in conjunction with the PartDesign Workbench to create extruded solids.

  1. Switch to the PartDesign Workbench.
  2. Press PartDesign Body.
  3. Press PartDesign NewSketch.
  4. Select feature: XY_Plane (Base plane), XZ_Plane (Base plane), or YZ_Plane (Base plane).
  5. Press OK.

Properties

See Property for all property types that scripted objects can have.

A Sketcher SketchObject (Sketcher::SketchObject class) is derived from a Part Part2DObject (Part::Part2DObject class), therefore it shares all the latter's properties.

In addition to the properties described in Part Part2DObject, the basic Sketcher SketchObject has the following properties in the property editor.

Data

Attachment

  • DatenMap Mode: See Part Attachment for more information on all attachment mapping modes.

Sketch

  • DatenConstraints: named constraints, if they exist; otherwise it is an empty list [].

View

Auto Constraints

  • AnsichtAutoconstraints: if true it will try setting constraints when the geometry is drawn.

Visibility automation

  • AnsichtEditing Workbench: normally SketcherWorkbench, it is the name of the workbench to activate when editing the sketch.
  • AnsichtHide Dependent: if true all objects that depend on the sketch are hidden when opening the sketch.
  • AnsichtRestore Camera: if true the camera position is saved before opening the sketch, and is restored after closing it.
  • AnsichtShow Links: if true all objects used in links to external geometry are shown when opening the sketch.
  • AnsichtShow Support: if true all objects this sketch is attached to are shown when opening the sketch.

Scripting

See also: FreeCAD Scripting Basics, and scripted objects.

See Part Feature for the general information on adding objects.

A Sketcher SketchObject is created with the addObject() method of the document.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObject", "Sketch")
obj.Label = "Custom label"